import React from 'react';
import { Theme } from '../cn';
export declare type AmountProps = {
    amount: {
        /**
         * Абсолютное значение суммы
         */
        value: number;
        /**
         * Валюта
         */
        currency: {
            /**
             * Международный код валюты
             */
            code: string;
            /**
             * Количество минорных единиц валюты
             */
            minority: number;
        };
    };
    /**
     * Отображение минорной части, если она нулевая
     */
    showZeroMinorPart?: boolean;
    /**
     * Размер компонента
     */
    size?: 's' | 'm' | 'l' | 'xl';
    /**
     * Толщина шрифта
     */
    bold?: boolean;
    /**
     * Использовать компонент `Heading` для вывода числа
     */
    isHeading?: boolean;
    /**
     * Тема компонента
     */
    theme?: Theme;
    /**
     * Дополнительный класс
     */
    className?: string;
    /**
     * Идентификатор компонента в DOM
     */
    id?: string;
    /**
     * Идентификатор для систем автоматизированного тестирования
     */
    'data-test-id'?: string;
};
/**
 * Компонент для отображения суммы, согласно следующему гайдлайну:
 * https://design.alfabank.ru/patterns/amount
 */
export declare class Amount extends React.Component<AmountProps> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    static defaultProps: Partial<AmountProps>;
    render(): JSX.Element;
    private renderSeparatorAndMinorPart;
    private renderCurrencySymbol;
}
declare const _default: React.ForwardRefExoticComponent<AmountProps & React.RefAttributes<Amount>> & Amount;
export default _default;
