/**
 * Разбирает введенную пользователем дату используя заданный формат.
 *
 * @param value Дата
 * @param format Ожидаемый формат даты
 */
export declare function parseDate(value: string, format: string): number | null;
/**
 * Изменяет формат даты с одного на другой.
 *
 * @param value Оригинальная строка с датой
 * @param inFormat Входной формат даты
 * @param outFormat Формат возвращаемой даты
 */
export declare function changeDateFormat(value: string, inFormat: string, outFormat: string): string;
/**
 * Возвращает дату с корректным месяцем.
 *
 * @param value Строка даты
 * @param format Формат строки с датой
 * @param earlierLimit Левая граница дат
 * @param laterLimit Правая граница дат
 */
export declare function calculateMonth(value: string, format: string, earlierLimit?: number, laterLimit?: number): number;
/**
 * Возвращает `true`, если поддерживается `input[type="date"]`
 */
export declare function isInputDateSupported(): boolean;
