"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getYearsRange = exports.isCurrentDay = void 0;
var start_of_today_1 = __importDefault(require("date-fns/start_of_today"));
var get_time_1 = __importDefault(require("date-fns/get_time"));
/**
 * Возвращает `true`, если переданная дата является текущей датой.
 *
 * @param date Дата для проверки
 */
function isCurrentDay(date) {
    if (date !== null) {
        return date.valueOf() === get_time_1.default(start_of_today_1.default());
    }
    return false;
}
exports.isCurrentDay = isCurrentDay;
/**
 * Возвращает массив - перечень лет, попадающих в переданный диапазон дат.
 * @param earlierLimit Начало диапазона дат
 * @param laterLimit Окончание диапазона дат
 * @returns Диапазон лет
 */
function getYearsRange(earlierLimit, laterLimit) {
    var years = [];
    var startYear = new Date(earlierLimit).getFullYear();
    var endYear = new Date(laterLimit).getFullYear();
    for (var currentYear = startYear; currentYear <= endYear; currentYear += 1) {
        years.push(currentYear);
    }
    return years.reverse();
}
exports.getYearsRange = getYearsRange;

//# sourceMappingURL=utils.js.map
