import React from 'react';
export declare type CollapseProps = {
    /**
     * Управление `expanded` состоянием компонента
     * */
    isExpanded?: boolean;
    /**
     * Текст ссылки в `expanded` состоянии
     * */
    collapsedLabel?: string;
    /**
     * Текст ссылки в `collapsed` состоянии
     * */
    expandedLabel?: string;
    /**
     * Дочерние элементы `Collapse`
     */
    children?: React.ReactNode;
    /**
     * Тема компонента
     */
    theme?: 'alfa-on-color' | 'alfa-on-white';
    /**
     * Дополнительный класс
     */
    className?: string;
    /**
     * Идентификатор компонента в DOM
     */
    id?: string;
    /**
     * Обработчик смены состояний `expanded/collapsed`
     */
    onExpandedChange?: (isExpanded?: boolean) => void;
    /**
     * Идентификатор для систем автоматизированного тестирования
     */
    'data-test-id'?: string;
};
/**
 * Компонент «подката» позволяет спрятать кусок текста за ссылку «Еще...».
 */
export declare class Collapse extends React.PureComponent<CollapseProps> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    static defaultProps: Partial<CollapseProps>;
    state: {
        isExpanded: boolean;
    };
    private content;
    private contentCase;
    componentDidMount(): void;
    componentDidUpdate(): void;
    render(): JSX.Element;
    private handleExpandedChange;
    private updateContentHeight;
}
declare const _default: React.ForwardRefExoticComponent<CollapseProps & React.RefAttributes<Collapse>> & Collapse;
export default _default;
