import React from 'react';
import { Theme } from '../cn';
export declare type IconProps = {
    /**
     * Дополнительный класс
     */
    className?: string;
    /**
     * Управление цветностью иконки
     */
    colored?: boolean;
    /**
     * Идентификатор компонента в DOM
     */
    id?: string;
    /**
     * Название иконки
     */
    name?: string;
    /**
     * Размер иконки
     */
    size?: 'xs' | 's' | 'm' | 'l' | 'xl' | 'xxl' | 'xxxl';
    /**
     * Тема компонента
     */
    theme?: Theme;
    /**
     * Идентификатор для систем автоматизированного тестирования
     */
    'data-test-id'?: string;
};
/**
 * Базовый компонент иконки. Содержит в себе только необходимые для компонентов иконки.
 */
export declare class Icon extends React.PureComponent<IconProps> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    static defaultProps: Partial<IconProps>;
    render(): JSX.Element;
}
declare const _default: React.ForwardRefExoticComponent<IconProps & React.RefAttributes<Icon>> & Icon;
export default _default;
