import React from 'react';
export declare type InputGroupProps = {
    /**
     * Управление возможностью компонента занимать всю ширину родителя
     */
    width?: 'default' | 'available';
    /**
     * Дочерние элементы `InputGroup`, как правило, компоненты `Input`
     */
    children?: React.ReactNode;
    /**
     * Тема компонента
     */
    theme?: 'alfa-on-color' | 'alfa-on-white';
    /**
     * Дополнительный класс
     */
    className?: string;
    /**
     * Идентификатор компонента в DOM
     */
    id?: string;
    /**
     * Идентификатор для систем автоматизированного тестирования
     */
    'data-test-id'?: string;
};
/**
 * Компонент группы полей для текстового ввода.
 */
export declare class InputGroup extends React.PureComponent<InputGroupProps> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    render(): JSX.Element;
}
declare const _default: React.ForwardRefExoticComponent<InputGroupProps & React.RefAttributes<InputGroup>> & InputGroup;
export default _default;
