import React from 'react';
import { InputProps } from '../input/input';
export declare type IntlPhoneInputProps = InputProps;
declare type IntlPhoneInputState = {
    countryIso2: string;
    inputFocused: boolean;
    inputValue: string;
    selectFocused: boolean;
    onceOpened: boolean;
};
/**
 * Компонент ввода международного телефона по маске.
 */
export declare class IntlPhoneInput extends React.PureComponent<IntlPhoneInputProps, IntlPhoneInputState> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    static defaultProps: Partial<IntlPhoneInputProps>;
    state: {
        countryIso2: string;
        inputFocused: boolean;
        inputValue: string;
        selectFocused: boolean;
        onceOpened: boolean;
    };
    private countries;
    input: any;
    private select;
    private timeoutId;
    private util;
    private asYouType;
    componentDidMount(): Promise<void>;
    UNSAFE_componentWillUpdate(nextProps: any, nextState: any): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
    renderFlagIcon(countryIso2: string): JSX.Element;
    private renderSelectButtonContent;
    private handleSelectFocus;
    private handleSelectButtonFocus;
    private handleSelectBlur;
    private handleSelectButtonBlur;
    private handleSelectChange;
    private handleSelectClick;
    private handleInputFocus;
    private handleInputBlur;
    private handleInputChange;
    getOptions: () => any;
    private getSelectPopupOffset;
    private getValue;
    loadUtil(): Promise<string | void>;
    private resolveFocusedState;
    private setCountry;
    private setValue;
    /**
     * Возвращает ссылку на HTMLElement инпута.
     */
    getControl(): HTMLInputElement;
    /**
     * Устанавливает фокус на поле ввода.
     */
    focus(): void;
    /**
     * Убирает фокус с поля ввода.
     */
    blur(): void;
    /**
     * Скроллит страницу до поля ввода.
     */
    scrollTo(): void;
}
declare const _default: React.ForwardRefExoticComponent<InputProps & React.RefAttributes<IntlPhoneInput>> & IntlPhoneInput;
export default _default;
