/**
 * Нормализирует дату, возвращает Date вне завистимости от входных данных.
 *
 * @param date Дата для нормализации.
 */
export declare function normalizeDate(date: Date | number): Date;
/**
 * Возвращает «правильный» индекс дня недели, 0 - пн, 1 - вт и так далее.
 *
 * @param date Дата, из которой нужно получить день недели.
 */
export declare function getRussianWeekDay(date: Date): number;
/**
 * Разбирает дату из строки по заданному формату.
 * Допустимые элементы формата:
 * D - дата, в формате 1-31
 * DD - дата, в формате 01-31,
 * M - месяц, в формате 1-12,
 * MM - месяц, в формате 01-12
 * YYYY - год
 * В качестве разделителей между элементами даты могут выступать любые символы, не являющиеся частью формата.
 *
 * @param input Входная строка для разбора.
 * @param format Формат, который будет использоваться для разбора.
 * @param strict Запрещать ли значения, выходящие за пределы логических ограничений месяцев/дней.
 * В случае если strict=false 22 месяц будет интерпретироваться как год и 10 месяцев.
 */
export declare function parse(input: string, format?: string, strict?: boolean): Date;
