export declare const THINSP: string;
export declare const AMOUNT_MAJOR_MINOR_PARTS_SEPARATOR = ",";
export declare type Amount = {
    /**
     * Абсолютное значение суммы
     */
    value: number;
    /**
     * Параметры валюты
     */
    currency: {
        /**
         * Код валюты
         */
        code: string;
        /**
         * Количество минорных единиц валюты
         */
        minority: number;
    };
};
declare type FormattedAmount = {
    /**
     * Мажорная часть суммы
     */
    majorPart: string;
    /**
     * Минорная часть суммы
     */
    minorPart: string;
    /**
     * Валюта целиком
     */
    value: string;
    /**
     * Символ валюты
     */
    currencySymbol: string;
};
/**
 * Форматирует значение суммы.
 */
export declare function formatAmount(amount: Amount): FormattedAmount;
/**
 * Форматирует значение суммы и возвращает в виде строки.
 * Использует функционал formatAmount
 */
export declare function formatAmountToString(amount: Amount): string;
export {};
