import React from 'react';
export declare type MqProps = {
    /**
     * Медиа запрос
     */
    query?: string;
    /**
     * Запрос на поддержку тач-событий
     */
    touch?: boolean;
    /**
     * Дочерние элементы `Mq`
     */
    children?: React.ReactNode;
    /**
     * Обработчик изменений в совпадении запросов
     */
    onMatchChange?: (isMatched?: boolean) => void;
};
declare type MqState = {
    isMatched: boolean;
};
/**
 * Компонент, имплементирующий поддержку медиа запросов в шаблонах.
 * Рендерит внутренние компоненты/разметку исходя из соответствия условиям запроса.
 * Для `query` используется window.matchMedia с полифиллом для IE9.
 * Можно использовать кастомные запросы из `src/mq/mq.json`, например `--small`.
 * Пока браузеры не поддерживают CSS4 Media Queries, поддержка тач-событий определяется через `touch`.
 */
declare class Mq extends React.Component<MqProps, MqState> {
    state: {
        isMatched: boolean;
    };
    private mql;
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): {};
    private handleMatch;
}
export default Mq;
