"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isTouchSupported = exports.isPointerEventsSupported = void 0;
/**
 * Возвращает `true`, если есть поддержка `Pointer Events`
 */
function isPointerEventsSupported() {
    return 'PointerEvent' in window || 'msPointerEnabled' in window.navigator;
}
exports.isPointerEventsSupported = isPointerEventsSupported;
/**
 * Возвращает `true`, если есть поддержка `Touch Events`
 */
function isTouchSupported() {
    return ('ontouchstart' in window
        || window.navigator.maxTouchPoints > 0
        || window.navigator.msMaxTouchPoints > 0);
}
exports.isTouchSupported = isTouchSupported;
exports.default = {
    isPointerEventsSupported: isPointerEventsSupported,
    isTouchSupported: isTouchSupported,
};

//# sourceMappingURL=utils.js.map
