import React from 'react';
import { Theme } from '../cn';
export declare type ParagraphProps = {
    /**
     * Тип параграфа
     */
    view?: 'lead' | 'normal' | 'small';
    /**
     * Маркер параграфа
     */
    mark?: React.ReactNode;
    /**
     * Дочерние элементы `Paragraph`
     */
    children?: React.ReactNode;
    /**
     * Тема компонента
     */
    theme?: Theme;
    /**
     * Дополнительный класс
     */
    className?: string;
    /**
     * Идентификатор компонента в DOM
     */
    id?: string;
    /**
     * Идентификатор для систем автоматизированного тестирования
     */
    'data-test-id'?: string;
};
/**
 * Компонент параграфа текста.
 */
export declare class Paragraph extends React.PureComponent<ParagraphProps> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    render(): JSX.Element;
}
declare const _default: React.ForwardRefExoticComponent<ParagraphProps & React.RefAttributes<Paragraph>> & Paragraph;
export default _default;
