import React from 'react';
export declare type ResizeSensorProps = {
    /**
     * Callback на изменение размера родителя
     */
    onResize?: () => void;
};
/**
 * Компонент позволяющий слушать изменения размера родительского элемента.
 * Для использования разместите его в элементе об изменении размера, которого
 * вы хотите знать и добавьте внешний обработчик `onResize`.
 *
 * Важно! Элемент, размер которого вы хотите измерять, должен обладать
 * css свойством `position: relative;`.
 */
export declare class ResizeSensor extends React.Component<ResizeSensorProps> {
    private iframe;
    componentDidMount(): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
    private handleResize;
}
export default ResizeSensor;
