import React from 'react';
export declare type TabsProps = {
    /**
     * Управление возможность скроллить компонент по-горизонтали
     */
    scrollable?: boolean;
    /**
     * Дочерние компоненты
     */
    children?: React.ReactNode;
    /**
     * Тема компонента
     */
    theme?: 'alfa-on-color' | 'alfa-on-white';
    /**
     * Дополнительный класс
     */
    className?: string;
    /**
     * Идентификатор компонента в DOM
     */
    id?: string;
    /**
     * Идентификатор для систем автоматизированного тестирования
     */
    'data-test-id'?: string;
};
/**
 * Компонент навигации в виде табов. Как правило используется совместно с `TabItem`.
 */
export declare class Tabs extends React.PureComponent<TabsProps> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    static defaultProps: Partial<TabsProps>;
    render(): JSX.Element;
}
declare const _default: React.ForwardRefExoticComponent<TabsProps & React.RefAttributes<Tabs>> & Tabs;
export default _default;
