"use strict";
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Tabs = void 0;
var react_1 = __importDefault(require("react"));
var bem_react_classname_1 = require("bem-react-classname");
var cn_1 = require("../cn");
/**
 * Компонент навигации в виде табов. Как правило используется совместно с `TabItem`.
 */
var Tabs = /** @class */ (function (_super) {
    __extends(Tabs, _super);
    function Tabs() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.cn = bem_react_classname_1.createCn('tabs');
        return _this;
    }
    Tabs.prototype.render = function () {
        return (react_1.default.createElement("div", { className: this.cn({ scrollable: this.props.scrollable }), id: this.props.id, "data-test-id": this.props['data-test-id'] },
            react_1.default.createElement("div", { className: this.cn('panel') },
                react_1.default.createElement("div", { className: this.cn('content') }, this.props.children))));
    };
    Tabs.defaultProps = {
        scrollable: true,
    };
    return Tabs;
}(react_1.default.PureComponent));
exports.Tabs = Tabs;
exports.default = cn_1.withTheme(Tabs);

//# sourceMappingURL=tabs.js.map
